-- Air Order of Battle for own (Player) side
-- Issues: LO Weather & LO TOD numbers.

-- Table Air Sub-Types
local airTypes = {
    ["1001"] = "None",
    ["2001"] = "Fighter",
    ["2002"] = "Multirole",
    ["2101"] = "ASAT",
    ["2102"] = "Airborne Laser Platform",
    ["3001"] = "Attack",
    ["3002"] = "Wild Weasel",
    ["3101"] = "Bomber",
    ["3401"] = "BAI/CAS",
    ["4001"] = "EW",
    ["4002"] = "AEW",
    ["4003"] = "ACP",
    ["4101"] = "SAR",
    ["4201"] = "MCM",
    ["6001"] = "ASW",
    ["6002"] = "MPA",
    ["7001"] = "Forward Observer",
    ["7002"] = "Area Surveillance",
    ["7003"] = "Recon",
    ["7004"] = "ELINT",
    ["7005"] = "SIGINT",
    ["7101"] = "Transport",
    ["7201"] = "Cargo",
    ["7301"] = "Commercial",
    ["7302"] = "Civilian",
    ["7401"] = "Utility",
    ["7402"] = "Naval Utility",
    ["8001"] = "Tanker",
    ["8101"] = "Trainer",
    ["8102"] = "Target Towing",
    ["8103"] = "Target Drone",
    ["8201"] = "UAV",
    ["8202"] = "UCAV",
    ["8901"] = "Airship",
    ["8902"] = "Aerostat",
    ["8903"] = "Balloon"
}

-- Table Sensor Types
local sensorTypes = {
    ["1001"] = "None",
    ["2001"] = "Radar",
    ["2002"] = "Semi-Active",
    ["2003"] = "Visual",
    ["2004"] = "InfraRed",
    ["2005"] = "TVM",
    ["3001"] = "ESM",
    ["3002"] = "ECM",
    ["3003"] = "EMP Projector",
    ["3004"] = "PCLS",
    ["4001"] = "Laser Designator",
    ["4002"] = "Laser Spot Tracker",
    ["4003"] = "Laser Rangefinder",
    ["5001"] = "HullSonar_PassiveOnly",
    ["5002"] = "HullSonar_ActivePassive",
    ["5003"] = "HullSonar_ActiveOnly",
    ["5011"] = "TowedArray_PassiveOnly",
    ["5012"] = "TowedArray_ActivePassive",
    ["5013"] = "TowedArray_ActiveOnly",
    ["5021"] = "VDS_PassiveOnly",
    ["5022"] = "VDS_ActivePassive",
    ["5023"] = "VDS_ActiveOnly",
    ["5031"] = "DippingSonar_PassiveOnly",
    ["5032"] = "DippingSonar_ActivePassive",
    ["5033"] = "DippingSonar_ActiveOnly",
    ["5041"] = "BottomFixedSonar_PassiveOnly",
    ["5101"] = "MAD",
    ["5901"] = "PingIntercept",
    ["6001"] = "MineSweep_MechanicalCableCutter",
    ["6002"] = "MineSweep_MagneticInfluence",
    ["6003"] = "MineSweep_AcousticInfluence",
    ["6004"] = "MineSweep_MultiInfluence",
    ["6011"] = "MineSweep_TwoShipMagneticInfluence",
    ["6021"] = "MineNeutralization_MooredMineCableCutter",
    ["6022"] = "MineNeutralization_ExplosiveChargeMineDisposal",
    ["6031"] = "MineNeutralization_DiverExplosiveCharge",
    ["8001"] = "NonDetectingEmitter",
    ["9001"] = "SensorGroup"
}

-- Table Sensor Roles
local sensorRoles = {
    ["1001"] = "None",
    ["2001"] = "AS 2D LR",
    ["2002"] = "AS 3D LR",
    ["2003"] = "AS 2D MR",
    ["2004"] = "AS 3D MR",
    ["2005"] = "AS 2D SR",
    ["2006"] = "AS 3D SR",
    ["2011"] = "AS/SS 2D LR",
    ["2012"] = "AS/SS 3D LR",
    ["2013"] = "AS/SS 2D MR",
    ["2014"] = "AS/SS 3D MR",
    ["2015"] = "AS/SS 2D SR",
    ["2016"] = "AS/SS 3D SR",
    ["2017"] = "HF LR",
    ["2018"] = "HF MR",
    ["2019"] = "HF SR",
    ["2021"] = "SS LR",
    ["2022"] = "SS MR",
    ["2023"] = "SS SR",
    ["2027"] = "SS OTH",
    ["2028"] = "SS Navigation",
    ["2031"] = "Navigation Only",
    ["2032"] = "Ground Mapping Only",
    ["2033"] = "Terrain Avoidance/Following",
    ["2034"] = "Weather Only",
    ["2035"] = "Weather/Navigation",
    ["2111"] = "FC Air-Air LR",
    ["2112"] = "FC Air-Air MR",
    ["2113"] = "FC Air-Air SR",
    ["2121"] = "FC LR",
    ["2122"] = "FC A/S MR",
    ["2123"] = "FC A/S SR",
    ["2124"] = "FC A/S LR",
    ["2125"] = "FC A/S MR",
    ["2126"] = "FC A/S SR",
    ["2131"] = "FC S-A LR",
    ["2191"] = "FC Gun Only",
    ["2201"] = "SAM Illuminator LR",
    ["2202"] = "SAM Illuminator MR",
    ["2203"] = "SAM Illuminator SR",
    ["2211"] = "Active Missile Seeker",
    ["2301"] = "Range Only",
    ["4001"] = "Offensive ECM",
    ["4011"] = "Defensive ECM",
    ["4021"] = "Off/Def ECM",
    ["4031"] = "ECM Repeater",
    ["4041"] = "IRCM",
    ["4091"] = "COMINT Jammer"
}

local loadoutRoles = {
    ["1001"] = "None",
    ["2001"] = "Intercept BVR",
    ["2002"] = "Intercept WVR",
    ["2003"] = "AirSuperiority BVR",
    ["2004"] = "AirSuperiority WVR",
    ["2005"] = "PointDefence BVR",
    ["2006"] = "PointDefence WVR",
    ["2007"] = "Guns Only",
    ["2101"] = "AntiSatellite Intercept",
    ["2102"] = "AirborneLaser",
    ["3001"] = "Land & Naval Strike",
    ["3002"] = "Land & Naval Standoff",
    ["3003"] = "Land& Naval SEAD ARM",
    ["3004"] = "Land & Naval SEAD TALD",
    ["3005"] = "Land & Naval DEAD",
    ["3101"] = "LandOnly Strike",
    ["3102"] = "LandOnly Standoff",
    ["3103"] = "LandOnly SEAD ARM",
    ["3104"] = "LandOnly SEAD TALD",
    ["3105"] = "LandOnly DEAD",
    ["3201"] = "NavalOnly Strike",
    ["3202"] = "NavalOnly Standoff",
    ["3203"] = "NavalOnly SEAD ARM",
    ["3204"] = "NavalOnly SEAD TALD",
    ["3205"] = "Naval Only DEAD",
    ["3401"] = "BAI_CAS",
    ["3501"] = "Buddy Illumination",
    ["4001"] = "OECM",
    ["4002"] = "AEW",
    ["4003"] = "Command Post",
    ["4004"] = "Chaff Laying",
    ["4101"] = "Search & Rescue",
    ["4102"] = "Combat Search & Rescue",
    ["4201"] = "Mine Sweeping",
    ["4202"] = "Mine Recon",
    ["4301"] = "Naval Mine Laying",
    ["6001"] = "ASW Patrol",
    ["6002"] = "ASW Attack",
    ["7001"] = "Forward Observer",
    ["7002"] = "Area Surveillance",
    ["7003"] = "Armed Recon",
    ["7004"] = "Unarmed Recon",
    ["7005"] = "Maritime Surveillance",
    ["7101"] = "Paratroopers",
    ["7102"] = "Troop Transport",
    ["7201"] = "Cargo",
    ["8001"] = "Air Refueling",
    ["8101"] = "Training",
    ["8102"] = "Target Tow",
    ["8103"] = "Target Drone",
    ["9001"] = "Ferry",
    ["9002"] = "Unavailable",
    ["9003"] = "Reserve",
    ["9004"] = "Armed Ferry"
}

local loadoutTimeOfDay = {          -- looks like all are 0, reported in LuaLegion
    ["0"] = "Lua Error tbd",
    ["1001"] = "None",              
    ["2001"] = "Day & Night",    
    ["2002"] = "Night Only",
    ["2003"] = "Day Only"
}

local loadoutWeather = {            -- looks like all are 0, reported in LuaLegion
    ["0"] = "Lua Error tbd",    
    ["1001"] = "None",
    ["2001"] = "All Weather",       
    ["2002"] = "Limited All Weather",
    ["2003"] = "Clear Weather"
}

-- Table Weapon Types
local weaponTypes = {
    ["1001"] = "None",
    ["2001"] = "Guided Weapon",
    ["2002"] = "Rocket",
    ["2003"] = "IronBomb",
    ["2004"] = "Gun",
    ["2005"] = "Decoy Expendable",
    ["2006"] = "Decoy Towed",
    ["2007"] = "Decoy Vehicle",
    ["2008"] = "Training Round",
    ["2009"] = "Dispenser",
    ["2010"] = "Contact-Bomb Suicide",
    ["2011"] = "Contact-Bomb Sabotage",
    ["2012"] = "Guided Projectile",
    ["2014"] = "UAV Expendable",
    ["3001"] = "Sensor Pod",
    ["3002"] = "Drop Tank",
    ["3003"] = "Buddy Store",
    ["3004"] = "Ferry Tank",
    ["4001"] = "Torpedo",
    ["4002"] = "Depth Charge",
    ["4003"] = "Sonobuoy",
    ["4004"] = "Bottom Mine",
    ["4005"] = "Moored Mine",
    ["4006"] = "Floating Mine",
    ["4007"] = "Moving Mine",
    ["4008"] = "Rising Mine",
    ["4009"] = "Drifting Mine",
    ["4011"] = "Dummy Mine",
    ["4101"] = "Heli Towed Package",
    ["5000"] = "Ballistic Missile",
    ["5001"] = "Rentry Vehicle",
    ["5002"] = "Pallet Weapon",
    ["6001"] = "Laser",
    ["6002"] = "Microwave",
    ["6003"] = "Laser Dazzler",
    ["8001"] = "Hypersonic Glide Vehicle",
    ["8003"] = "Hypersonic Cruise Missile",
    ["9001"] = "Cargo",
    ["9002"] = "Troops",
    ["9003"] = "Paratroops"
}

-- Add gKH State Management and Notes System
if gKH == nil then gKH = {} end
if gKH.State ~= nil then
    gKH.State = nil
    gKH.json = nil
    collectgarbage("collect")
end
gKH.State = {}

-- Add JSON handling functions
gKH.json = {}

-- JSON handling functions
gKH.json = {}

function gKH.json.kind_of(obj)
    if type(obj) ~= 'table' then return type(obj) end
    local i = 1
    for _ in pairs(obj) do
        if obj[i] ~= nil then i = i + 1 else return 'table' end
    end
    if i == 1 then return 'table' else return 'array' end
end

function gKH.json.escape_str(s)
    local in_char  = {'\\', '"', '/', '\b', '\f', '\n', '\r', '\t'}
    local out_char = {'\\', '"', '/',  'b',  'f',  'n',  'r',  't'}
    for i, c in ipairs(in_char) do
        s = s:gsub(c, '\\' .. out_char[i])
    end
    return s
end

function gKH.json.skip_delim(str, pos, delim, err_if_missing)
    pos = pos + #str:match('^%s*', pos)
    if str:sub(pos, pos) ~= delim then
        if err_if_missing then
            error('Expected ' .. delim .. ' near position ' .. pos)
        end
        return pos, false
    end
    return pos + 1, true
end

function gKH.json.parse_str_val(str, pos, val)
    val = val or ''
    local early_end_error = 'End of input found while parsing string.'
    if pos > #str then error(early_end_error) end
    local c = str:sub(pos, pos)
    if c == '"'  then return val, pos + 1 end
    if c ~= '\\' then return gKH.json.parse_str_val(str, pos + 1, val .. c) end
    local esc_map = {b = '\b', f = '\f', n = '\n', r = '\r', t = '\t'}
    local nextc = str:sub(pos + 1, pos + 1)
    if not nextc then error(early_end_error) end
    return gKH.json.parse_str_val(str, pos + 2, val .. (esc_map[nextc] or nextc))
end

function gKH.json.parse_num_val(str, pos)
    local num_str = str:match('^-?%d+%.?%d*[eE]?[+-]?%d*', pos)
    local val = tonumber(num_str)
    if not val then error('Error parsing number at position ' .. pos .. '.') end
    return val, pos + #num_str
end

function gKH.json.stringify(obj, as_key)
    local s = {}
    local kind = gKH.json.kind_of(obj)
    if kind == 'array' then
        if as_key then error('Can\'t encode array as key.') end
        s[#s + 1] = '['
        for i, val in ipairs(obj) do
            if i > 1 then s[#s + 1] = ', ' end
            s[#s + 1] = gKH.json.stringify(val)
        end
        s[#s + 1] = ']'
    elseif kind == 'table' then
        if as_key then error('Can\'t encode table as key.') end
        s[#s + 1] = '{'
        for k, v in pairs(obj) do
            if #s > 1 then s[#s + 1] = ', ' end
            s[#s + 1] = gKH.json.stringify(k, true)
            s[#s + 1] = ':'
            s[#s + 1] = gKH.json.stringify(v)
        end
        s[#s + 1] = '}'
    elseif kind == 'string' then
        return '"' .. gKH.json.escape_str(obj) .. '"'
    elseif kind == 'number' then
        if as_key then return '"' .. tostring(obj) .. '"' end
        return tostring(obj)
    elseif kind == 'boolean' then
        return tostring(obj)
    elseif kind == 'nil' then
        return 'null'
    else
        error('Unjsonifiable type: ' .. kind .. '.')
    end
    return table.concat(s)
end

function gKH.json.parse(str, pos, end_delim)
    pos = pos or 1
    if pos > #str then error('Reached unexpected end of input.') end
    local pos = pos + #str:match('^%s*', pos)
    local first = str:sub(pos, pos)
    if first == '{' then
        local obj, key, delim_found = {}, true, true
        pos = pos + 1
        while true do
            key, pos = gKH.json.parse(str, pos, '}')
            if key == nil then return obj, pos end
            if not delim_found then error('Comma missing between object items.') end
            pos = gKH.json.skip_delim(str, pos, ':', true)
            obj[key], pos = gKH.json.parse(str, pos)
            pos, delim_found = gKH.json.skip_delim(str, pos, ',')
        end
    elseif first == '[' then
        local arr, val, delim_found = {}, true, true
        pos = pos + 1
        while true do
            val, pos = gKH.json.parse(str, pos, ']')
            if val == nil then return arr, pos end
            if not delim_found then error('Comma missing between array items.') end
            arr[#arr + 1] = val
            pos, delim_found = gKH.json.skip_delim(str, pos, ',')
        end
    elseif first == '"' then
        return gKH.json.parse_str_val(str, pos + 1)
    elseif first == '-' or first:match('%d') then
        return gKH.json.parse_num_val(str, pos)
    elseif first == end_delim then
        return nil, pos + 1
    else
        local literals = {['true'] = true, ['false'] = false, ['null'] = gKH.json.null}
        for lit_str, lit_val in pairs(literals) do
            local lit_end = pos + #lit_str - 1
            if str:sub(pos, lit_end) == lit_str then return lit_val, lit_end + 1 end
        end
        local pos_info_str = 'position ' .. pos .. ': ' .. str:sub(pos, pos + 10)
        error('Invalid json syntax starting at ' .. pos_info_str)
    end
end

-- State management functions 
function gKH.State.SaveTableToKey(theTbl, theKey)
    if theTbl ~= nil and theKey ~= nil and string.len(theKey) > 0 then
        return pcall(ScenEdit_SetKeyValue, theKey, gKH.json.stringify(theTbl))
    end
    return false
end

function gKH.State.LoadTableFromKey(theKey)
    if theKey ~= nil and string.len(theKey) > 0 then
        local retval, theKeyData = pcall(ScenEdit_GetKeyValue, theKey)
        if retval ~= nil and theKeyData ~= nil and retval == true and string.len(theKeyData) > 2 then
            return gKH.json.parse(theKeyData)
        end
    end
    return nil
end

-- Notes System
local NOTES_KEY = "AIRCRAFT_NOTES_V1"
local currentNotes = {}

-- Load existing notes
currentNotes = gKH.State.LoadTableFromKey(NOTES_KEY) or {}

function SaveNote(guid, noteText)
    print("SaveNote called with guid: " .. guid .. ", text: " .. noteText)
    currentNotes[guid] = noteText
    return gKH.State.SaveTableToKey(currentNotes, NOTES_KEY)
end

local currentNotesJSON = gKH.json.stringify(currentNotes)

-- Helper Functions --

local function GetLoadoutInfo(unit)
    local loadout = ScenEdit_GetLoadout({unitname = unit.guid})
    local result = {
        name = loadout and loadout.name or "",
        role = "None",
        roleCode = loadout and loadout.roles and tostring(loadout.roles.role) or "1001",
        dbid = loadout and loadout.dbid or "",
        weather = loadout and loadout.roles and loadout.roles.weather or "0",
        tod = loadout and loadout.roles and loadout.roles.TOD or "0"
    }
    result.role = loadoutRoles[result.roleCode] or "None"        
    return result
end

local function GetLoadoutWeaponsInfo(unit)
    local loadout = ScenEdit_GetLoadout({unitname = unit.guid})
    if loadout and loadout.weapons then
        local weaponsInfo = ""
        for _, weapon in pairs(loadout.weapons) do
            if weaponsInfo ~= "" then
                weaponsInfo = weaponsInfo .. "|"
            end
            -- Get additional weapon info from database
            local weaponDB = ScenEdit_QueryDB('weapon', weapon.wpn_dbid)
            local targetList = ""
            if weaponDB.validTargetList then
                targetList = table.concat(weaponDB.validTargetList, ',')
            end
            
            -- Process ranges
            local rangeInfo = {}
            if weaponDB.ranges then
                for domain, range in pairs(weaponDB.ranges) do
                    if range.max > 0 or range.min > 0 then
                        table.insert(rangeInfo, string.format("%s:%.1f-%.1f", 
                            domain, 
                            range.min or 0, 
                            range.max or 0))
                    end
                end
            end
            local rangeStr = table.concat(rangeInfo, ';')
            
            weaponsInfo = weaponsInfo .. weapon.wpn_name .. ";" .. 
                                       weapon.wpn_current .. ";" .. 
                                       weapon.wpn_maxcap .. ";" .. 
                                       weapon.wpn_type .. ";" ..
                                       weapon.wpn_dbid .. ";" ..
                                       targetList .. ";" ..
                                       rangeStr
        end
        return weaponsInfo
    end
    return ""
end

-- Add this before creating the rows string
local function GetAGL(unit)
    if not unit or not unit.latitude or not unit.longitude then
        return 0  -- Return safe default if missing data
    end
    local elevation = World_GetElevation({
        latitude = unit.latitude,
        longitude = unit.longitude
    })
    -- If elevation is negative (underwater), use 0 instead
    if elevation < 0 then
        elevation = 0
    end
    return unit.altitude - elevation
end

-- For the main table
local function getProficiencyDot(proficiency)
    local dotClass = ""
    proficiency = string.lower(proficiency)
    if proficiency == "ace" then
        dotClass = "ace"
    elseif proficiency == "veteran" then
        dotClass = "veteran"
    elseif proficiency == "regular" then
        dotClass = "regular"
    elseif proficiency == "cadet" then
        dotClass = "cadet"
    elseif proficiency == "novice" then
        dotClass = "novice"
    end
    return string.format('<div class="proficiency-dot-table %s" title="%s"></div>', dotClass, proficiency:gsub("^%l", string.upper))
end

-- Compare playerside with 'assigned' base of unit [chk for CPE]
local function IsHomebaseFriendly(unit)
    local playerSide = VP_GetSide({Side="playerside"})
    if unit.base and unit.base.side then
        if unit.base.side ~= playerSide.name then
            -- Return the actual side name instead of just true/false
            return unit.base.side
        end
    end
    return false
end

-- sensor info
local function GetSensorInfo(unit)
    if not unit or not unit.sensors then return "" end
    
    local sensorStr = ""
    local validSensorTypes = {[2001]=true, [3002]=true, [9001]=true}
    
    for _, sensor in pairs(unit.sensors) do
        if validSensorTypes[sensor.sensor_type] then
            local sType = sensorTypes[tostring(sensor.sensor_type)] or "Unknown"
            local role = sensorRoles[tostring(sensor.sensor_role)] or tostring(sensor.sensor_role)
            local active = sensor.sensor_isactive == true and "Active" or "Inactive"
            -- Query sensor DB for range info
            local sensorDB = ScenEdit_QueryDB('sensor', sensor.sensor_dbid)
            local maxRange = sensorDB and sensorDB.ranges and sensorDB.ranges.max or "N/A"
            sensorStr = sensorStr .. "|" .. sensor.sensor_name .. ";" .. sType .. ";" .. role .. ";" .. active .. ";" .. maxRange
        end
    end
    return sensorStr:sub(2) -- Remove the first '|'
end

-- Helper function to determine if unit is airborne
local function IsAirborne(condition)
    return condition == 'Airborne' or
           condition == 'Landing_PreTouchdown' or
           condition == 'RTB' or
           condition == 'ManoeuveringToRefuel' or
           condition == 'Refuelling' or
           condition == 'OffloadingFuel' or
           condition == 'DeployingDippingSonar' or
           condition == 'EmergencyLanding' or
           condition == 'BVRAttack' or
           condition == 'BVRCrank' or
           condition == 'Dogfight' or
           condition == 'TransferringCargo' or
           condition == 'BVRDrag'
end

-- Helper function to get fuel percentage and color class
local function GetFuelDot(fuelInfo)
    if fuelInfo == "No fuel data available" then
        return ""
    end

    local current, max = string.match(fuelInfo, "current: ([-0-9.]+), max: ([-0-9.]+)")
    if current and max then
        local percentage = (tonumber(current) / tonumber(max)) * 100
        local colorClass = ""
        if percentage >= 66 then
            colorClass = "high"
        elseif percentage >= 33 then
            colorClass = "medium"
        else
            colorClass = "low"
        end
        -- Simplified tooltip to show only percentage
        return string.format(' <div class="fuel-dot %s" title="Fuel: %.1f%%"></div>', 
            colorClass, 
            percentage)
    end
    return ""
end

local loadoutRolesJSON = "{"
for k, v in pairs(loadoutRoles) do
    loadoutRolesJSON = loadoutRolesJSON .. string.format('"%s":"%s",', k, v)
end
loadoutRolesJSON = loadoutRolesJSON:sub(1, -2) .. "}"

local loadoutWeatherJSON = "{"
for k, v in pairs(loadoutWeather) do
    loadoutWeatherJSON = loadoutWeatherJSON .. string.format('"%s":"%s",', k, v)
end
loadoutWeatherJSON = loadoutWeatherJSON:sub(1, -2) .. "}"

local loadoutTimeOfDayJSON = "{"
for k, v in pairs(loadoutTimeOfDay) do
    loadoutTimeOfDayJSON = loadoutTimeOfDayJSON .. string.format('"%s":"%s",', k, v)
end
loadoutTimeOfDayJSON = loadoutTimeOfDayJSON:sub(1, -2) .. "}"

local weaponTypesJSON = "{"
for k, v in pairs(weaponTypes) do
    weaponTypesJSON = weaponTypesJSON .. string.format('"%s":"%s",', k, v)
end
weaponTypesJSON = weaponTypesJSON:sub(1, -2) .. "}"


-- Collect and process all aircraft data
local function CollectAircraftData()
    -- Get the player's side with error handling
    local side = VP_GetSide({Side="playerside"})
    if not side then 
        return "", 0, "Unknown Side" 
    end
    
    local sideName = side.name or "Player Side"
    local unitlist = side:unitsBy('Aircraft')
    local rows = ""
    local aircraftCount = 0
    
    -- Process each aircraft
    for _, v in ipairs(unitlist) do
        local u = SE_GetUnit({guid=v.guid})
        if u then
            local subtypeName = airTypes[tostring(u.subtype)] or "Unknown"
            local loadoutInfo = GetLoadoutInfo(u)
            
            -- Check if loadout name contains "[Unavailable]" and assign class accordingly
            local isMaintenance = string.find(loadoutInfo.name, "%[Unavailable%]") ~= nil and "maintenance" or "normal"
            
            -- Get fuel information
            local fuelInfo = ""
            if u.fuel then
                for fuelType, fuelData in pairs(u.fuel) do
                    if fuelData.current and fuelData.max and fuelData.name and fuelData.type then
                        fuelInfo = string.format("name: %s, current: %.2f, max: %.2f", 
                            fuelData.name, 
                            fuelData.current, 
                            fuelData.max)
                        break  -- Since aircraft typically only have one fuel type
                    end
                end
            end
            if fuelInfo == "" then
                fuelInfo = "No fuel data available"
            end
            
            -- Extract other fields
            local loadoutdbid = u.loadoutdbid or "None"
            local airbornetime = "N/A"
            if u.airbornetime_v and tonumber(u.airbornetime_v) > 0 then
                local totalSeconds = tonumber(u.airbornetime_v)
                local days = math.floor(totalSeconds / 86400)
                totalSeconds = totalSeconds % 86400
                local hours = math.floor(totalSeconds / 3600)
                totalSeconds = totalSeconds % 3600
                local minutes = math.floor(totalSeconds / 60)
                local seconds = totalSeconds % 60
                
                if days > 0 then
                    airbornetime = string.format("%d:%02d:%02d:%02d", days, hours, minutes, seconds)
                elseif hours > 0 then
                    airbornetime = string.format("%02d:%02d:%02d", hours, minutes, seconds)
                else
                    airbornetime = string.format("%02d:%02d", minutes, seconds)
                end
            end

            local readytime = ""
            if string.find(loadoutInfo.name, "%[Unavailable%]") then
                -- If unit is in maintenance, keep empty string
                readytime = ""
            elseif u.readytime and tonumber(u.readytime) ~= 0 then
                -- If unit has a ready time not equal to 0, show that time
                readytime = tostring(u.readytime)
            else
                -- If unit is not in maintenance and ready time is 0 or nil, show "Ready"
                readytime = "Ready"
            end

local condition = tostring(u.condition_v) or "Unknown"
            
            local baseLatitude = "N/A"
            local baseLongitude = "N/A"
            local horizontalDist = "N/A"
            local slantDist = "N/A"

            if u.base then
                baseLatitude = u.base.latitude
                baseLongitude = u.base.longitude
                
                -- Calculate distances if unit has position and base has position
                if u.latitude and u.longitude and baseLatitude and baseLongitude then
                    local fromPoint = {latitude = u.latitude, longitude = u.longitude, altitude = u.altitude or 0}
                    local toPoint = {latitude = baseLatitude, longitude = baseLongitude, altitude = 0}
                    
                    horizontalDist = tonumber(Tool_Range(fromPoint, toPoint)) or 0
                    slantDist = tonumber(Tool_Range(fromPoint, toPoint, true)) or 0
                end
            end

            local groupName = ""
            if u.group then
                groupName = u.group.name
            end
            
            if u.mission then
                missionName = u.mission.name
                missionType = u.mission.typeS or u.mission.type
                missionActive = u.mission.isactive
                missionDataAttr = tostring(u.mission.name)
                missionStartTime = u.mission.starttime or "N/A"
                missionEndTime = u.mission.endtime or "N/A"
                missionSubType = "N/A"
                
                -- Check if this is a real mission
                if u.mission.name and u.mission.name ~= "" and u.mission.side then
                    local mission = ScenEdit_GetMission(u.mission.side, missionName)
                    if mission then
                        missionSubType = mission.subtype or "N/A"
                    end
                else
                    -- Reset all mission values if it's not a real mission
                    missionName = "N/A"
                    missionType = "N/A"
                    missionActive = false
                    missionDataAttr = "N/A"
                    missionStartTime = "N/A"
                    missionEndTime = "N/A"
                end
            else
                -- Set default values for units without missions
                missionName = "N/A"
                missionType = "N/A"
                missionActive = false
                missionDataAttr = "N/A"
                missionStartTime = "N/A"
                missionEndTime = "N/A"
                missionSubType = "N/A"
            end

            aircraftCount = aircraftCount + 1

            -- Add the table row with the class
-- Add the table row with the class
local loadoutInfo = GetLoadoutInfo(u)

-- Add notes indicator check here
local notesIndicator = ""
if currentNotes[v.guid] and currentNotes[v.guid] ~= "" then
    -- Escape any quotes in the note text to prevent breaking the HTML
    local noteText = string.gsub(currentNotes[v.guid], '"', '&quot;')
    notesIndicator = string.format('<div class="notes-check tooltip" data-tooltip="%s">✓</div>', noteText)
end

    local timeOfDay = ScenEdit_GetTimeOfDay({guid=v.guid})
    local currentTOD = tostring(timeOfDay.tod)


    rows = rows .. string.format(
        "<tr class='%s' data-category='%s' data-mission='%s'><td class='clickable-cell' onclick=\"selectUnitInGame('%s', %.4f, %.4f); showUnitDetails('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', %.4f, %.4f, '%s', '%s', %.4f, %.4f, %.1f, %.1f, '%s', '%s', '%s', '%s', '%s', '%s', '%s', %.4f, %.4f, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')\">%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>",
        isMaintenance,
        tostring(u.category),
        missionDataAttr,
        v.guid,
        tonumber(u.latitude) or 0,
        tonumber(u.longitude) or 0,
        v.name,
        subtypeName,
        tostring(u.classname),
        tostring(u.base.name),
        loadoutInfo.name,
        readytime,
        condition,
        airbornetime,
        tostring(u.crew or "N/A"),
        tostring(u.dbid or "N/A"),
        tostring(u.proficiency or "N/A"),
        tonumber(u.latitude) or 0,
        tonumber(u.longitude) or 0,
        tostring(u.jammer or "N/A"),
        tostring(u.jammed or "N/A"),
        tonumber(baseLatitude) or 0,
        tonumber(baseLongitude) or 0,
        tonumber(horizontalDist) or 0,
        tonumber(slantDist) or 0,
        groupName,
        missionName,
        missionType,
        tostring(missionActive),
        tostring(missionStartTime),
        tostring(missionEndTime),
        fuelInfo,
        tonumber(u.altitude) or 0,
        tonumber(GetAGL(u)) or 0,
        GetSensorInfo(u),
        tostring(missionSubType or "N/A"),
        loadoutInfo.role,
        tostring(loadoutInfo.dbid),
        tostring(loadoutInfo.roleCode),
        tostring(loadoutInfo.weather),
        tostring(loadoutInfo.tod),
        GetLoadoutWeaponsInfo(u),
        v.guid,
        currentTOD,
        v.name,
        subtypeName,
        tostring(u.classname),
        groupName,
        string.format('%s%s', tostring(u.base.name), IsHomebaseFriendly(u) and string.format(' <div class="base-dot friendly" title="%s Base"></div>', IsHomebaseFriendly(u)) or ''),
        loadoutInfo.role,
        readytime,
        condition .. (IsAirborne(condition) and GetFuelDot(fuelInfo) or ""),
        getProficiencyDot(tostring(u.proficiency)),
        (u.mission and string.format('<div class="mission-dot assigned" title="Mission: %s"></div>', missionName)) or '<div class="mission-dot unassigned" title="Mission: None"></div>',
        notesIndicator
      )
        end
    end
    
    return rows, aircraftCount, sideName
end

-- Use the collected data
local tableRows, aircraftCount, sideName = CollectAircraftData()

-- HTML content including JavaScript
local htmlAir = string.format([[
<!DOCTYPE html>
<html>
<head>
    <title>Air Order of Battle - %s</title>

<!-- Required scripts -->
<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"></script>
<link rel="stylesheet" href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css" />

    <!--
    ============================================
    =               CSS STYLING                =
    ============================================
    -->
    <style>
        /* Base Styles */
        body {
            background-color: #1e1e1e;
            color: #cfcfcf;
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 20px;
        }

        h1 {
            text-align: center;
            color: #ffffff;
        }

        /* Table Styles */
        table {
            width: 100%%;
            border-collapse: collapse;
            margin-top: 20px;
        }

        th, td {
            border: 1px solid #444444;
            padding: 8px;
            text-align: left;
        }

        th {
            background-color: #333333;
            color: #ffffff;
            cursor: pointer;
        }

        th.sorted-asc::after {
            content: " ▼";
        }

        th.sorted-desc::after {
            content: " ▲";
        }

        tr:nth-child(even) {
            background-color: #2c2c2c;
        }

        tr:nth-child(odd) {
            background-color: #1f1f1f;
        }

        tr:hover {
            background-color: #444444;
        }

        /* Filter Styles */
        .filters {
            display: flex;
            flex-wrap: wrap;
            gap: 10px;
            justify-content: space-between;
            margin-bottom: 20px;
        }

        .filter-group {
            flex: 1 1 calc(33.33%% - 10px);
        }

        .filter-input, .filter-select {
        width: 95%%;
        background-color: #2c2c2c;    /* Dark grey background */
        color: #cfcfcf;               /* Less bright text - changed from #ffffff */
        border: 1px solid #444444;    /* Darker grey border */
        padding: 5px;
        border-radius: 4px;
        }

        /* Style for placeholder text */
        .filter-input::placeholder {
        color: #888888;               /* Light grey placeholder text */
        }

        /* Style for placeholder text */
        .filter-input::placeholder {
        color: #888888;              /* Light grey placeholder text */
        }

        /* Style for select options */
        .filter-select option {
        background-color: #2c2c2c;    /* Dark grey background for dropdown options */
        color: #cfcfcf;               /* Less bright text - changed from #ffffff */
        }

        /* Optional: Style for when the input/select is focused */
        .filter-input:focus, .filter-select:focus {
        outline: none;
        border-color: #0056b3;        /* Blue border when focused */
        box-shadow: 0 0 0 1px #0056b3;
        }

        /* Button Styles */

.proficiency-dot {
    display: inline-block;
    width: 12px;         /* Made slightly larger */
    height: 12px;        /* Made slightly larger */
    border-radius: 50%%;
    margin: 0 auto;      /* Center in the cell */
    cursor: help;        /* Shows hand cursor on hover */
}

    .proficiency-dot.ace {
        background-color: #3498db;  /* Blue */
    }

    .proficiency-dot.veteran {
        background-color: #8B4513;  /* Brown */
    }

    .proficiency-dot.regular {
        background-color: #2ecc71;  /* Green */
    }

    .proficiency-dot.cadet {
        background-color: #f1c40f;  /* Yellow */
    }

    .proficiency-dot.novice {
        background-color: #e67e22;  /* Orange */
    }
    
    /* For the main table - larger, centered dot */
.proficiency-dot-table {
    display: inline-block;
    width: 12px;
    height: 12px;
    border-radius: 50%%;
    margin: 0 auto;
    cursor: help;
}

/* For the side panel - smaller dot with margin */
.proficiency-dot-panel {
    display: inline-block;
    width: 8px;
    height: 8px;
    border-radius: 50%%;
    margin-left: 6px;
    vertical-align: middle;
}

/* Common colors for both types of dots */
.proficiency-dot-table.ace,
.proficiency-dot-panel.ace {
    background-color: #3498db;  /* Blue */
}

.proficiency-dot-table.veteran,
.proficiency-dot-panel.veteran {
    background-color: #8B4513;  /* Brown */
}

.proficiency-dot-table.regular,
.proficiency-dot-panel.regular {
    background-color: #2ecc71;  /* Green */
}

.proficiency-dot-table.cadet,
.proficiency-dot-panel.cadet {
    background-color: #f1c40f;  /* Yellow */
}

.proficiency-dot-table.novice,
.proficiency-dot-panel.novice {
    background-color: #e74c3c;  /* Changed from #e67e22 (orange) to #e74c3c (red) */
}

        .export-button {
        padding: 5px 20px;
        background-color: #333333;
        color: #cfcfcf;               /* Less bright text - changed from #ffffff */
        border: none;
        border-radius: 4px;
        cursor: pointer;
        margin-bottom: 20px;
        }

        .export-button:hover {
        background-color: #0056b3;
        color: #cfcfcf;               /* Keep text color consistent when hovering */
        }

        /* Pagination Styles */
        .pagination {
            display: flex;
            justify-content: center;
            gap: 10px;
            margin: 20px 0;
        }

        .pagination button {
            padding: 5px 15px;
            background-color: #333333;
            color: #ffffff;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        .pagination button:hover {
            background-color: #444444;
        }

        .pagination button.active {
            background-color: #0056b3;
        }

        .pagination button:disabled {
            background-color: #1e1e1e;
            cursor: not-allowed;
        }



        .detail-row {
            margin-bottom: 8px;
            font-family: Arial, sans-serif;
            font-size: 14px;
        }

        .detail-row span:not(.label) {
            font-family: 'Segoe UI', sans-serif;
            font-size: 14px;
            color: #ffffff;
        }

        .detail-row .label {
            font-family: 'Segoe UI', sans-serif;
            font-size: 13px;
            color: #9e9e9e;
            font-weight: 600;
        }

        #unitDetails h3 {
            font-family: 'Segoe UI', sans-serif;
            font-size: 22px;
            color: #2980b9;
            margin-bottom: 25px;
        }

        /* Slide Panel Styles */
.slide-panel {
    position: fixed;
    top: 0;
    right: -33%%;
    width: 33%%;
    height: 100%%;
    background-color: #2c2c2c;
    box-shadow: -2px 0 5px rgba(0,0,0,0.5);
    transition: right 0.3s ease-in-out;
    z-index: 1000;
    overflow-y: auto;
    padding: 20px;
    overflow-x: hidden;
}

.slide-panel.active {
    right: 0;
}

        .toggle-button.active {
    right: 33%%;      /* Changed from 50%% to 33%% */
}

        /* Toggle Button Styles */
.toggle-button {
    position: fixed;
    top: 50%%;
    transform: translateY(-50%%);
    width: 30px;
    height: 60px;
    background-color: #333333;
    border: none;
    border-radius: 5px 0 0 5px;
    cursor: pointer;
    color: white;
    z-index: 1001;
    transition: right 0.3s ease-in-out;
    right: 0;
}

.toggle-button:hover {
    background-color: #0056b3;
}

.toggle-button.active {
    right: 33%%;
}

.toggle-button.inactive {
    right: 0;
}

        /* Utility Classes */
        .maintenance {
            background-color: #ff6b6b;
        }

        .normal {
            background-color: #2c2c2c;
        }

        .hidden {
            display: none;
        }

        .hidden-column {
            display: none;
        }

        .clickable-cell {
            cursor: pointer;
            color: #cfcfcf;
        }

        .clickable-cell:hover {
            color: #2980b9;
            background-color: #444444;
        }

.main-content {
    transition: margin-right 0.3s ease-in-out;
    padding-right: 30px;
}

.main-content.shifted {
    margin-right: calc(33%% + 30px);
}

.detail-content {
    padding: 20px;
    overflow-x: hidden;  /* Add this line */
}
        
        /* Modal Styles */
        .modal {
        display: none;
        position: fixed;
        top: 0;
        left: 0;
        width: 100%%;
        height: 100%%;
        background-color: rgba(0, 0, 0, 0.7);
        z-index: 1000;
        }

        .modal-content {
        position: fixed;
        top: 50%%;
        left: 50%%;
        transform: translate(-50%%, -50%%);
        background-color: #2c2c2c;
        padding: 20px;
        border-radius: 8px;
        min-width: 300px;
        }

        .modal-content h3 {
        color: #cfcfcf;
        margin-bottom: 20px;
        }

        .column-toggles {
        display: flex;
        flex-direction: column;
        gap: 10px;
        margin-bottom: 20px;
        }

        .column-toggles label {
        color: #cfcfcf;
        display: flex;
        align-items: center;
        gap: 8px;
        }

        .column-toggles input[type="checkbox"] {
        margin: 0;
        cursor: pointer;
        }

/* Also update the detail-group padding */
.detail-group {
    position: relative;
    margin-bottom: 15px;      /* Reduced from 25px */
    padding: 8px;    /* Reduced from 15 and 10px to make it more compact */
    background-color: #1e1e1e;
    border-radius: 8px;
    transition: all 0.3s ease;
}

.collapse-arrow {
    position: absolute;
    top: 10px;
    right: 10px;
    cursor: pointer;
    color: #9e9e9e;
    transition: transform 0.3s ease;
}

.collapse-arrow:hover {
    color: #ffffff;
}

.detail-group.collapsed .collapse-arrow {
    transform: rotate(180deg);
}

.detail-group.collapsed .detail-content {
    display: none;
}

/* Also add this class */
.detail-row > .navigation-arrow {
    display: none;
}

/* Change it to */
.detail-group h4 {
    margin: 0;  /* Removed bottom margin completely */
    font-family: 'Segoe UI', sans-serif;
    font-size: 16px;
    color: #9e9e9e;  /* Changed to grey to match other labels, #2980b9 was blue for block header */
}

/* And update the content spacing */
.detail-content {
    margin-top: 2px;  /* Reduced from 5px to bring content closer to header */
}

.detail-row {
    margin-bottom: 4px;            /* Reduced from 8px */
    font-family: Arial, sans-serif;
    font-size: 14px;
}

.detail-row:last-child {
    margin-bottom: 0;
}

.panel-header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 15px;
}

.toggle-all-button {
    padding: 5px 10px;
    background-color: #333333;
    color: #cfcfcf;
    border: none;
    border-radius: 4px;
    cursor: pointer;
    font-size: 12px;
}

.toggle-all-button:hover {
    background-color: #0056b3;
}

.fuel-bar-container {
    width: 100%%;
    height: 10px;        /* Changed from 20px to 10px */
    background-color: #2c2c2c;
    border-radius: 5px;  /* Also reduced from 10px to 5px to match new height */
    overflow: hidden;
    margin-top: 4px;
}

.fuel-bar {
    height: 100%%;
    background-color: #2980b9;
    transition: width 0.3s ease;
}

.fuel-text {
    margin-left: 8px;
    font-size: 12px;
    color: #9e9e9e;
}

.fuel-name {
    color: #ffffff;
    font-size: 14px;
    margin-bottom: 4px;
}

.status-dot {
    display: inline-block;
    width: 8px;
    height: 8px;
    border-radius: 50%%;
    margin-left: 6px;
}

.status-dot.active {
    background-color: #f39c12;  /* orange */
}

.status-dot.inactive {
    background-color: #2ecc71;  /* green */
}

.status-dot.reserve {
    background-color: #f1c40f;  /* yellow */
}

.status-dot.maintenance {
    background-color: #e74c3c;  /* red */
}

.mission-dot {
    display: inline-block;
    width: 10px;
    height: 10px;
    border-radius: 50%%;
    margin: 0 auto;
}

.mission-dot.assigned {
    background-color: #3498db;  /* Blue */
}

.mission-dot.unassigned {
    background-color: #e67e22;  /* Orange */
}

.mission-dot[title] {
    cursor: help;
}

.base-dot {
    display: inline-block;
    width: 8px;
    height: 8px;
    border-radius: 50%%;
    margin-left: 6px;
    vertical-align: middle;  /* Added this to align dot with text */
}

.base-dot.friendly {
    background-color: #9b59b6;  /* Purple */
}

.fuel-dot {
    display: inline-block;
    width: 8px;
    height: 8px;
    border-radius: 50%%;
    margin-left: 6px;
}

.fuel-dot.high {
    background-color: #2ecc71;  /* Green */
}

.fuel-dot.medium {
    background-color: #f39c12;  /* Orange */
}

.fuel-dot.low {
    background-color: #e74c3c;  /* Red */
}

.weapon-line {
    margin-left: 20px;
    color: #cfcfcf;
    font-size: 14px;
}

.weapon-details-block {
    margin-top: 10px;
    margin-left: 20px;
    border-left: 2px solid #444444;
}

.weapon-details-header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: 4px 8px;
    cursor: pointer;
    color: #888888;
}

.weapon-details-header:hover {
    background-color: #383838;
}

.weapon-details-content {
    padding: 8px;
    display: none;
}

.weapon-detail-line {
    padding: 4px 8px;
    font-size: 13px;
    color: #cfcfcf;
    display: block;
    margin-left: 20px;
}

.weapon-detail-line .detail-label {
    color: #888888;
    display: inline;
    margin-right: 8px;
}

.weapon-details-block.collapsed .collapse-arrow {
    transform: rotate(-90deg);
}

.weapon-details-block:not(.collapsed) .weapon-details-content {
    display: block;
}

.weapon-detail-row {
    display: flex;
    justify-content: space-between;
    padding: 4px 8px;
    font-size: 13px;
}

.weapon-name {
    color: #cfcfcf;
}

.weapon-type {
    color: #888888;
}

.weapons-header {
    display: flex;
    align-items: center;
    gap: 10px;
    margin-bottom: 8px;
}

.details-button {
    background-color: #2c2c2c;
    border: 1px solid #444444;
    color: #888888;
    padding: 2px 8px;
    border-radius: 4px;
    font-size: 12px;
    cursor: pointer;
}

.details-button:hover {
    background-color: #383838;
    color: #cfcfcf;
}

.weapon-container {
    margin-left: 20px;
}

.weapon-details {
    margin-left: 20px;
    padding-left: 8px;
    border-left: 2px solid #444444;
    margin-bottom: 8px;
    display: none;
}

.weapon-details:not(.collapsed) {
    display: block;
}

.weapon-line {
    color: #cfcfcf;
    font-size: 14px;
    margin-bottom: 4px;
}

.weapon-target-list {
    margin-left: 40px;
    margin-bottom: 8px;
}

.weapon-detail-subline {
    font-size: 13px;
    color: #cfcfcf;
    padding: 2px 0;
}

.error-message {
    color: #e74c3c;
    padding: 20px;
    text-align: center;
    background-color: rgba(231, 76, 60, 0.1);
    border-radius: 4px;
    margin: 10px 0;
}

.weapon-range-row {
    margin-left: 20px;
    font-size: 13px;
    color: #888888;
}

.unit-marker, .base-marker {
    display: flex;
    justify-content: center;
    align-items: center;
    font-size: 20px;
}

.leaflet-popup-content-wrapper {
    background-color: #2c2c2c;
    color: #ffffff;
}

.leaflet-popup-tip {
    background-color: #2c2c2c;
}

/* Notes field styling */
.notes-field {
    width: 100%%;
    background-color: #2c2c2c;
    color: #cfcfcf;
    border: 1px solid #444444;
    padding: 8px 12px;  /* Increased padding */
    border-radius: 4px;
    font-size: 14px;    /* Increased from 13px */
    font-family: 'Segoe UI', Arial, sans-serif;  /* Changed font */
}

.notes-field:focus {
    outline: none;
    border-color: #0056b3;
    box-shadow: 0 0 0 1px #0056b3;
}

.notes-field::placeholder {
    color: #888888;
}

.detail-content textarea.notes-field {
    width: 98%%;     /* Changed from 100%% to give some margin */
    min-height: 120px;   /* Increased from 100px */
    background-color: #2c2c2c;
    color: #cfcfcf;
    border: 1px solid #444444;
    padding: 12px;       /* Increased padding */
    border-radius: 4px;
    font-family: 'Segoe UI', Arial, sans-serif;
    font-size: 18px;     /* Increased from 13px */
    line-height: 1.4;    /* Added line height for better readability */
    resize: vertical;
    margin-top: 5px;
    letter-spacing: 0.2px;  /* Added slight letter spacing */
}

.detail-content textarea.notes-field:focus {
    outline: none;
    border-color: #0056b3;
    box-shadow: 0 0 0 1px #0056b3;
}


.detail-content textarea.notes-field::placeholder {
    color: #888888;
    font-size: 14px;    /* Match the text size */
}

.notes-check {
    display: inline-block;
    width: 12px;
    height: 12px;
    margin: 0 auto;
    color: #3498db;  /* Blue color */
    cursor: help;
    font-weight: bold;
    font-size: 14px;
    line-height: 12px;
}

.tooltip {
    position: relative;
    cursor: pointer;
}

.tooltip::after {
    content: attr(data-tooltip);
    position: absolute;
    left: 50%%;
    top: -5px;
    transform: translateX(-100%%) translateY(-125%%);
    background-color: #242424;
    color: #cfcfcf;
    padding: 10px 12px;          /* Increased padding */
    border-radius: 4px;
    font-size: 14px;
    font-family: 'Segoe UI', Arial, sans-serif;
    font-weight: 450;
    white-space: pre-wrap;
    min-width: 200px;            /* Added minimum width */
    max-width: 400px;            /* Increased from 300px */
    width: max-content;          /* Added to allow natural width */
    border: 1px solid #444444;
    box-shadow: 0 2px 5px rgba(0,0,0,0.2);
    z-index: 1000;
    display: none;
    line-height: 1.4;           /* Added for better text spacing */
    text-align: left;           /* Ensure text aligns left */
}

.tooltip:hover::after {
    display: block;
}

select option {
    background-color: #2c2c2c;
    padding: 5px;
}

select option.nonplayer-base::after {
    content: " ●";
    color: #9b59b6;
    display: inline-block;
}

    </style>
<!-- END OF CSS STYLING -->
</head>

<script>
const loadoutRoles = %s;
const loadoutWeather = %s;
const loadoutTimeOfDay = %s;
const weaponTypes = %s;
const currentNotes = %s;  // This is crucial
</script>

<!--
============================================
=              HTML CONTENT                =
============================================
-->
<body>
    <div class="main-content">
        <!-- Header Section -->
        <h1>Air ORBAT (%s) <br>A/C in List: <span id="aircraftCount">%d</span></h1>
        
<!-- Control Buttons -->
<button id="toggleButton" class="export-button" onclick="toggleFilter()">Included Unavailable</button>
<button id="aircraftTypeButton" class="export-button" onclick="toggleAircraftType()" title="Select All / Only Rotary / Only Fixed Wing">All Types</button>
<button id="missionFilterButton" class="export-button" onclick="toggleMissionFilter()" title="All Units / All Units in Mission / All Units not in Mission">All Units</button>
<button class="export-button" onclick="resetFilters()">Reset Filters</button>
<button class="export-button" onclick="openColumnModal()">Show/Hide Columns</button>


<!-- Column Toggle Modal -->
<div id="columnModal" class="modal">
    <div class="modal-content">
        <h3>Show/Hide Columns</h3>
        <div class="column-toggles">
            <label><input type="checkbox" checked onchange="toggleColumn(3)"> Group</label>
            <label><input type="checkbox" checked onchange="toggleColumn(4)"> Homebase</label>
            <label><input type="checkbox" checked onchange="toggleColumn(5)"> LO Role</label>
            <label><input type="checkbox" checked onchange="toggleColumn(6)"> ReadyTime</label>
            <label><input type="checkbox" checked onchange="toggleColumn(7)"> Condition</label>
            <label><input type="checkbox" onchange="toggleColumn(8)"> Proficiency</label>
            <label><input type="checkbox" onchange="toggleColumn(9)"> Mission Status</label>
            <label><input type="checkbox" checked onchange="toggleColumn(10)"> Notes</label>
        </div>
        <button class="export-button" onclick="closeColumnModal()">Close</button>
    </div>
</div>

        <!-- Filter Section -->
        <div class="filters">
            <div class="filter-group">
                <input type="text" id="filterName" class="filter-input" placeholder="Filter by Name" oninput="applyFilters()">
            </div>
            <div class="filter-group">
                <select id="filterSubType" class="filter-select" onchange="applyFilters()">
                    <option value="">Filter by SubType</option>
                </select>
            </div>
            <div class="filter-group">
                <select id="filterHomebase" class="filter-select" onchange="applyFilters()">
                    <option value="">Filter by Homebase</option>
                </select>
            </div>
            <div class="filter-group">
                <select id="filterLORole" class="filter-select" onchange="applyFilters()">
                    <option value="">Filter by LO Role</option>
                </select>
            </div>
            <div class="filter-group">
                <select id="filterClass" class="filter-select" onchange="applyFilters()">
                    <option value="">Filter by Class</option>
                </select>
            </div>
            <div class="filter-group">
                <select id="filterCondition" class="filter-select" onchange="applyFilters()">
                    <option value="">Filter by Condition</option>
                </select>
            </div>
        </div>

        <!-- Main Table -->
        <table>
            <thead>
            <tr>
                <th onclick="sortTable(0)">Name</th>
                <th onclick="sortTable(1)">SubType</th>
                <th onclick="sortTable(2)">Class</th>
                <th onclick="sortTable(3)">Group</th>
                <th onclick="sortTable(4)" title="Purple dot indicates a homebase not belonging to player side">Homebase</th>
                <th onclick="sortTable(5)">LO Role</th>
                <th onclick="sortTable(6)">ReadyTime</th>
                <th onclick="sortTable(7)">Condition</th>
                <th onclick="sortTable(8)">Proficiency</th>
                <th onclick="sortTable(9)">Misn</th>
                <th onclick="sortTable(10)" title="✓ notes available">Nts</th>
            </tr>
            </thead>
            <tbody id="aircraftTableBody">
                %s
            </tbody>
        </table>

        <!-- Pagination -->
        <div class="pagination"></div>
    </div>

<!-- Single toggle button for slide panel -->
<button id="togglePanel" class="toggle-button inactive" onclick="togglePanel()">
    <span id="toggleArrow">◀</span>
</button>

<div id="slidePanel" class="slide-panel">
    <div class="detail-content">
        <div id="unitDetails">
            Select a unit to view details
        </div>
    </div>
</div>
<!-- END OF HTML code part -->    

<!--
============================================
=            JAVASCRIPT CODE               =
============================================
-->
<script>

// At the top of your JavaScript section, add:
const CONFIG = {
    ROWS_PER_PAGE: 12,
    MIN_FUEL_HIGH: 66,
    MIN_FUEL_MEDIUM: 33,
};

// Constants for condition states
const AIRBORNE_CONDITIONS = new Set([
    'Airborne',
    'Landing_PreTouchdown',
    'RTB',
    'ManoeuveringToRefuel',
    'Refuelling',
    'OffloadingFuel',
    'DeployingDippingSonar',
    'EmergencyLanding',
    'BVRAttack',
    'BVRCrank',
    'Dogfight',
    'TransferringCargo',
    'BVRDrag'
]);

function IsAirborne(condition) {
    return AIRBORNE_CONDITIONS.has(condition);
}

// ===========================================
// Global Variables and Configuration
// ===========================================
    let unavailableIncluded = true;
    let currentPage = 1;
    const rowsPerPage = 12;
    let filteredRows = [];
    let sortDirection = {};
    let isPanelOpen = false;
    let missionFilterState = 'all';


// ===========================================
// Utility Functions
// ===========================================
function debounce(func, wait) {
    let timeout;
    return function(...args) {
        clearTimeout(timeout);
        timeout = setTimeout(() => func.apply(this, args), wait);
    };
}

function saveNote(element) {
    const guid = element.getAttribute('data-guid');
    const value = element.value;
    
    // Save the note
    window.chrome.webview.postMessage(`DIALOG_OKSaveNote('${guid}', '${value}')`);
    
    // Update currentNotes object in memory
    currentNotes[guid] = value;
    
    // Find and update the corresponding table cell
    const tableRows = document.querySelectorAll('#aircraftTableBody tr');
    tableRows.forEach(row => {
        const firstCell = row.cells[0];
        if (firstCell && firstCell.onclick && firstCell.onclick.toString().includes(guid)) {
            // Get the notes column (last column)
            const notesCell = row.cells[row.cells.length - 1];
            if (notesCell) {
                if (value && value.trim() !== '') {
                    // Add or update the notes check icon with tooltip
                    notesCell.innerHTML = `<div class="notes-check tooltip" data-tooltip="${value.replace(/"/g, '&quot;')}">✓</div>`;
                } else {
                    // Clear the cell if note is empty
                    notesCell.innerHTML = '';
                }
            }
        }
    });
}

const debouncedSave = debounce(saveNote, 500);

function IsAirborne(condition) {
    return AIRBORNE_CONDITIONS.has(condition);
}

// ===========================================
// Pagination Functions
// ===========================================
    function setupPagination() {
        const totalPages = Math.ceil(filteredRows.length / rowsPerPage);
        const paginationDiv = document.querySelector('.pagination');
        paginationDiv.innerHTML = '';
        
        // Previous button
        const prevButton = document.createElement('button');
        prevButton.innerText = '←';
        prevButton.disabled = currentPage === 1;
        prevButton.onclick = () => {
            if (currentPage > 1) {
                currentPage--;
                displayRows();
            }
        };
        paginationDiv.appendChild(prevButton);
        
        // Calculate range of page numbers to show
        let startPage = Math.max(1, currentPage - 2);
        let endPage = Math.min(totalPages, currentPage + 2);
        
        // Adjust range if at the edges
        if (currentPage <= 3) {
            endPage = Math.min(5, totalPages);
        }
        if (currentPage >= totalPages - 2) {
            startPage = Math.max(1, totalPages - 4);
        }
        
        // First page and ellipsis if needed
        if (startPage > 1) {
            const firstButton = document.createElement('button');
            firstButton.innerText = '1';
            firstButton.onclick = () => {
                currentPage = 1;
                displayRows();
            };
            paginationDiv.appendChild(firstButton);
            
            if (startPage > 2) {
                const ellipsis = document.createElement('span');
                ellipsis.innerText = '...';
                ellipsis.style.margin = '0 5px';
                ellipsis.style.color = '#ffffff';
                paginationDiv.appendChild(ellipsis);
            }
        }
        
        // Page numbers
        for (let i = startPage; i <= endPage; i++) {
            const button = document.createElement('button');
            button.innerText = i;
            button.classList.toggle('active', i === currentPage);
            button.onclick = () => {
                currentPage = i;
                displayRows();
            };
            paginationDiv.appendChild(button);
        }
        
        // Last page and ellipsis if needed
        if (endPage < totalPages) {
            if (endPage < totalPages - 1) {
                const ellipsis = document.createElement('span');
                ellipsis.innerText = '...';
                ellipsis.style.margin = '0 5px';
                ellipsis.style.color = '#ffffff';
                paginationDiv.appendChild(ellipsis);
            }
            
            const lastButton = document.createElement('button');
            lastButton.innerText = totalPages;
            lastButton.onclick = () => {
                currentPage = totalPages;
                displayRows();
            };
            paginationDiv.appendChild(lastButton);
        }
        
        // Next button
        const nextButton = document.createElement('button');
        nextButton.innerText = '→';
        nextButton.disabled = currentPage === totalPages;
        nextButton.onclick = () => {
            if (currentPage < totalPages) {
                currentPage++;
                displayRows();
            }
        };
        paginationDiv.appendChild(nextButton);
    }

function displayRows() {
    const tableBody = document.getElementById('aircraftTableBody');
    const start = (currentPage - 1) * rowsPerPage;
    const end = start + rowsPerPage;
    
    // Hide all rows first
    const allRows = tableBody.querySelectorAll('tr');
    allRows.forEach(row => row.style.display = 'none');
    
    // Get visible rows based on unavailable filter
    let visibleRows = filteredRows;
    if (!unavailableIncluded) {
        visibleRows = filteredRows.filter(row => !row.classList.contains('maintenance'));
    }
    
    // Find the next page if current page has no visible rows
    if (start >= visibleRows.length && currentPage > 1) {
        currentPage = Math.ceil(visibleRows.length / rowsPerPage) || 1;
        return displayRows(); // Recursive call with adjusted page
    }
    
    // Show rows for current page
    visibleRows.slice(start, end).forEach(row => {
        if (unavailableIncluded || !row.classList.contains('maintenance')) {
            row.style.display = '';
        }
    });
    
    // If we have less than rowsPerPage visible rows on this page,
    // and we have more rows available, show more from the next page
    let shownRows = visibleRows.slice(start, end).filter(row => 
        row.style.display !== 'none'
    ).length;
    
    let nextIndex = end;
    while (shownRows < rowsPerPage && nextIndex < visibleRows.length) {
        const row = visibleRows[nextIndex];
        if (unavailableIncluded || !row.classList.contains('maintenance')) {
            row.style.display = '';
            shownRows++;
        }
        nextIndex++;
    }
    
    setupPagination();
}

// ===========================================
// Filter Functions
// ===========================================
function toggleAircraftType() {
    const button = document.getElementById('aircraftTypeButton');
    if (button.textContent === 'All Types') {
        button.textContent = 'Helo';
    } else if (button.textContent === 'Helo') {
        button.textContent = 'FW';
    } else {
        button.textContent = 'All Types';
    }
    applyFilters();
}

function toggleMissionFilter() {
    const button = document.getElementById('missionFilterButton');
    switch(missionFilterState) {
        case 'all':
            missionFilterState = 'mission';
            button.textContent = 'In Misn';
            break;    
        case 'mission':
            missionFilterState = 'nomission';
            button.textContent = 'No Misn';
            break;
        case 'nomission':
            missionFilterState = 'all';
            button.textContent = 'All Units';
            break;
    }
    applyFilters();
}

function applyFilters() {
    const filters = {
        name: document.getElementById('filterName').value.toLowerCase(),
        lorole: document.getElementById('filterLORole').value.toLowerCase(),
        homebase: document.getElementById('filterHomebase').value.toLowerCase(),
        subType: document.getElementById('filterSubType').value.toLowerCase(),
        class: document.getElementById('filterClass').value.toLowerCase(),
        condition: document.getElementById('filterCondition').value.toLowerCase()
    };
    const allRows = Array.from(document.querySelectorAll('#aircraftTableBody tr'));
   
    filteredRows = allRows.filter(row => {
        const cells = row.cells;
        const conditionText = cells[7].textContent.split('◆')[0].trim().toLowerCase();
        const category = row.getAttribute('data-category');
        const missionStatus = row.getAttribute('data-mission');
        const aircraftTypeButton = document.getElementById('aircraftTypeButton').textContent;
        
        // Modified homebase handling
        const homebaseHTML = cells[4].innerHTML;
        const baseName = homebaseHTML.includes('<') ? 
            homebaseHTML.substring(0, homebaseHTML.indexOf('<')).trim() : 
            homebaseHTML.trim();
        const passesHomebase = !filters.homebase || baseName.toLowerCase() === filters.homebase;
       
        const passesAircraftType =
            aircraftTypeButton === 'All Types' ||
            (aircraftTypeButton === 'Helo' && category === '2003') ||
            (aircraftTypeButton === 'FW' && category !== '2003');

        const passesMission =
            missionFilterState === 'all' ||
            (missionFilterState === 'mission' && missionStatus !== 'N/A') ||
            (missionFilterState === 'nomission' && missionStatus === 'N/A');

        const passesDropdowns =
            (!filters.name || cells[0].innerText.toLowerCase().includes(filters.name)) &&
            (!filters.subType || cells[1].innerText.toLowerCase() === filters.subType) &&
            (!filters.class || cells[2].innerText.toLowerCase() === filters.class) &&
            (!filters.lorole || cells[5].innerText.toLowerCase() === filters.lorole) &&
            (!filters.condition || conditionText === filters.condition);

        return passesHomebase && passesAircraftType && passesMission && passesDropdowns;
    });

    updateFilterOptions();
    currentPage = 1;
    displayRows();
    updateAircraftCount();
}

function resetFilters() {
    // Clear filters
    document.getElementById('filterName').value = '';
    document.getElementById('filterLORole').value = '';
    document.getElementById('filterHomebase').value = '';
    document.getElementById('filterSubType').value = '';
    document.getElementById('filterClass').value = '';
    document.getElementById('filterCondition').value = '';
    
    // Reset buttons
    document.getElementById('aircraftTypeButton').textContent = 'All Types';
    document.getElementById('missionFilterButton').textContent = 'All Units';
    
    // Reset states
    missionFilterState = 'all';
    aircraftTypeState = 'all';
    
    // Reset rows
    const allRows = Array.from(document.querySelectorAll('#aircraftTableBody tr'));
    filteredRows = allRows;

    // Refresh dropdowns
    populateDropdowns();
    
    currentPage = 1;
    displayRows();
    updateAircraftCount();
}


    
function toggleFilter() {
    const maintenanceRows = document.querySelectorAll('tr.maintenance');
    const toggleButton = document.getElementById('toggleButton');
    
    unavailableIncluded = !unavailableIncluded;
    
    maintenanceRows.forEach(function(row) {
        row.classList.toggle('hidden');
    });
    
    toggleButton.textContent = unavailableIncluded ? 'Included Unavailable' : 'Excluded Unavailable';
    
    // Force a refresh of the current page
    displayRows();
    
    // Update the count after toggling
    updateAircraftCount();
}

function toggleAircraftType() {
    const button = document.getElementById('aircraftTypeButton');
    if (button.textContent === 'All Types') {
        button.textContent = 'Helo';
    } else if (button.textContent === 'Helo') {
        button.textContent = 'FW';
    } else {
        button.textContent = 'All Types';
    }
    applyFilters();
}

function toggleDetailGroup(arrow) {
    const group = arrow.parentElement;
    group.classList.toggle('collapsed');
    
    // Save state to localStorage (optional)
    const groupId = group.querySelector('h4').textContent;
    localStorage.setItem('detailGroup_' + groupId, group.classList.contains('collapsed'));
}

function toggleAllWeaponDetails(button) {
    const weaponsSection = button.closest('.weapons-section');
    const details = weaponsSection.querySelectorAll('.weapon-details');
    const isAnyVisible = Array.from(details).some(detail => !detail.classList.contains('collapsed'));
    
    details.forEach(detail => {
        if (isAnyVisible) {
            detail.classList.add('collapsed');
            button.textContent = 'Details';
        } else {
            detail.classList.remove('collapsed');
            button.textContent = 'Hide';
        }
    });
}

function toggleAllSensorDetails(button) {
    const sensorSection = button.closest('.weapons-section');
    const details = sensorSection.querySelectorAll('.weapon-details');
    const isAnyVisible = Array.from(details).some(detail => !detail.classList.contains('collapsed'));
    
    details.forEach(detail => {
        if (isAnyVisible) {
            detail.classList.add('collapsed');
            button.textContent = 'Details';
        } else {
            detail.classList.remove('collapsed');
            button.textContent = 'Hide';
        }
    });
}

// ===========================================
// Table Management Functions
// ===========================================
function getSortValue(cell, columnIndex) {
    const text = cell.innerText.trim();
    
    // Get the column header text to identify the column type
    const headerText = document.querySelector(`th:nth-child(${columnIndex + 1})`).textContent.trim();
    
    // Handle proficiency based on column header rather than index
    if (headerText === 'Proficiency') {
        const profMap = {
            'ace': 5,
            'veteran': 4,
            'regular': 3,
            'cadet': 2,
            'novice': 1
        };
        const profClass = cell.querySelector('.proficiency-dot-table')?.classList[1];
        return profMap[profClass] || 0;
    }
    
    // Special handling for Notes column
    if (headerText === 'Nts') {
        return cell.querySelector('.notes-check') ? 1 : 0;
    }
    
    // Special handling for ReadyTime column
    if (headerText === 'ReadyTime') {
        if (text === '') return -1;
        if (text === 'Ready') return 0;
        
        let totalMinutes = 0;
        if (text.includes('hr')) {
            const matches = text.match(/(\d+)\s*hr(?:\s*(\d+)\s*min)?/);
            if (matches) {
                totalMinutes = parseInt(matches[1]) * 60;
                if (matches[2]) totalMinutes += parseInt(matches[2]);
            }
        } else if (text.includes('min')) {
            const matches = text.match(/(\d+)\s*min/);
            if (matches) {
                totalMinutes = parseInt(matches[1]);
            }
        }
        return totalMinutes || parseInt(text) || 999999;
    }
    
    // Handle mission dots
    if (headerText === 'Misn') {
        return cell.querySelector('.mission-dot.assigned') ? 1 : 0;
    }
    
    // Handle numeric values
    if (!isNaN(text)) return parseFloat(text);
    
    return text.toLowerCase();
}

function sortTable(columnIndex) {
    const tableBody = document.querySelector("tbody");
    const headers = document.querySelectorAll("th");
    const headerText = headers[columnIndex].textContent.trim();
    
    headers.forEach((header, index) => {
        if (index !== columnIndex) {
            header.classList.remove("sorted-asc", "sorted-desc");
        }
    });

    const currentState = headers[columnIndex].classList.contains("sorted-asc") ? "asc" :
                        headers[columnIndex].classList.contains("sorted-desc") ? "desc" : "none";
    
    headers[columnIndex].classList.remove("sorted-asc", "sorted-desc");

    if (["Name", "SubType", "Class", "Group", "Homebase", "Condition", "LO Role"].includes(headerText)) {
        switch (currentState) {
            case "none":
                // First click: Z-A, 9-0
                headers[columnIndex].classList.add("sorted-asc");
                sortDirection[columnIndex] = "asc";
                break;
            case "asc":
                // Second click: A-Z, 0-9
                headers[columnIndex].classList.add("sorted-desc");
                sortDirection[columnIndex] = "desc";
                break;
            case "desc":
                // Third click: Reset to default
                sortDirection[columnIndex] = "none";
                sortTable(2);
                return;
        }
    } else if (headerText === "Proficiency") {
        // Rest of the code remains the same
        switch (currentState) {
            case "none":
                headers[columnIndex].classList.add("sorted-desc");
                sortDirection[columnIndex] = "desc";
                break;
            case "desc":
                headers[columnIndex].classList.add("sorted-asc");
                sortDirection[columnIndex] = "asc";
                break;
            case "asc":
                sortDirection[columnIndex] = "none";
                sortTable(2);
                return;
        }
    } else {
        switch (currentState) {
            case "none":
                headers[columnIndex].classList.add("sorted-asc");
                sortDirection[columnIndex] = "desc";
                break;
            case "asc":
                headers[columnIndex].classList.add("sorted-desc");
                sortDirection[columnIndex] = "asc";
                break;
            case "desc":
                sortDirection[columnIndex] = "none";
                sortTable(2);
                return;
        }
    }

    filteredRows.sort((a, b) => {
        const aVal = getSortValue(a.cells[columnIndex], columnIndex);
        const bVal = getSortValue(b.cells[columnIndex], columnIndex);
        
        if (sortDirection[columnIndex] === "asc") {
            return aVal > bVal ? 1 : -1;
        } else {
            return bVal > aVal ? 1 : -1;
        }
    });

    filteredRows.forEach(row => tableBody.appendChild(row));
    currentPage = 1;
    displayRows();
    updateAircraftCount();
}

function toggleMissionFilter() {
    const button = document.getElementById('missionFilterButton');
    switch(missionFilterState) {
        case 'all':
            missionFilterState = 'mission';
            button.textContent = 'In Misn';
            break;    
        case 'mission':
            missionFilterState = 'nomission';
            button.textContent = 'No Misn';
            break;
        case 'nomission':
            missionFilterState = 'all';
            button.textContent = 'All Units';
            break;
    }
    applyFilters();
}

function toggleColumn(columnIndex) {
    const table = document.querySelector('table');
    const rows = table.querySelectorAll('tr');   
    rows.forEach(row => {
    const cell = row.cells[columnIndex];
        if (cell) {
            cell.classList.toggle('hidden-column');
        }
    });
}

            // Populate dropdown options dynamically based on table data
function populateDropdowns() {
    const subTypeSet = new Set();
    const classSet = new Set();
    const homebasesWithSide = new Set();
    const conditionSet = new Set();                  
    const loRoleSet = new Set();
    const rows = document.querySelectorAll('#aircraftTableBody tr');
    
    rows.forEach(row => {
        const cells = row.cells;
        const conditionText = cells[7].textContent.split('◆')[0].trim();
        const homebaseHTML = cells[4].innerHTML;
        
        // Handle homebase with side information
        if (homebaseHTML.includes('base-dot friendly')) {
            const baseName = homebaseHTML.substring(0, homebaseHTML.indexOf('<')).trim();
            homebasesWithSide.add(`${baseName}#nonplayer`); // Using # as separator
        } else {
            const baseName = homebaseHTML.includes('<') ? 
                homebaseHTML.substring(0, homebaseHTML.indexOf('<')).trim() : 
                homebaseHTML.trim();
            homebasesWithSide.add(`${baseName}#player`);
        }
        
        subTypeSet.add(cells[1].innerText.trim());
        classSet.add(cells[2].innerText.trim());
        conditionSet.add(conditionText);
        loRoleSet.add(cells[5].innerText.trim());
    });

    updateDropdown('filterSubType', Array.from(subTypeSet).sort());
    updateDropdown('filterClass', Array.from(classSet).sort());
    updateDropdown('filterHomebase', Array.from(homebasesWithSide).sort());
    updateDropdown('filterCondition', Array.from(conditionSet).sort());
    updateDropdown('filterLORole', Array.from(loRoleSet).sort());
    updateAircraftCount();
}

function updateDropdown(elementId, options) {
    const dropdown = document.getElementById(elementId);
    const currentValue = dropdown.value;
    
    dropdown.innerHTML = `<option value="">Filter by ${elementId.replace('filter', '')}</option>`;
    
    if (elementId === 'filterHomebase') {
        options.forEach(option => {
            const [baseName, side] = option.split('#');
            const opt = document.createElement('option');
            opt.value = baseName;
            opt.textContent = baseName + (side === 'nonplayer' ? ' ●' : '');
            opt.className = side === 'nonplayer' ? 'nonplayer-base' : '';
            if (baseName === currentValue) opt.selected = true;
            dropdown.appendChild(opt);
        });
    } else {
        options.forEach(option => {
            const opt = document.createElement('option');
            opt.value = option;
            opt.textContent = option;
            if (option === currentValue) opt.selected = true;
            dropdown.appendChild(opt);
        });
    }
}

function updateFilterOptions() {
    const visibleRows = filteredRows;        
    const subTypeSet = new Set();
    const classSet = new Set();
    const homebaseSet = new Set();
    const conditionSet = new Set();                  
    const loRoleSet = new Set();
    
    visibleRows.forEach(row => {
        subTypeSet.add(row.cells[1].innerText.trim());
        classSet.add(row.cells[2].innerText.trim());
        homebaseSet.add(row.cells[4].innerText.trim());
        loRoleSet.add(row.cells[5].innerText.trim());
        conditionSet.add(row.cells[7].innerText.trim());
        
    });

    const currentSelections = {
        subType: document.getElementById('filterSubType').value,
        class: document.getElementById('filterClass').value,
        homebase: document.getElementById('filterHomebase').value,
        condition: document.getElementById('filterCondition').value,
        lorole: document.getElementById('filterLORole').value
    };

    const dropdowns = {
        'filterSubType': Array.from(subTypeSet),
        'filterClass': Array.from(classSet),
        'filterHomebase': Array.from(homebaseSet),
        'filterCondition': Array.from(conditionSet),
        'filterLORole': Array.from(loRoleSet)
    };

    Object.entries(dropdowns).forEach(([elementId, options]) => {
    const dropdown = document.getElementById(elementId);
    const selectionKey = elementId.replace('filter', '').toLowerCase();
    const currentValue = document.getElementById(elementId).value;  // Changed this line
    
    dropdown.innerHTML = '<option value="">Filter by ' + elementId.replace('filter', '') + '</option>';            
    options.sort().forEach(option => {
        const opt = document.createElement('option');
        opt.value = option;
        opt.innerText = option;
        if (option === currentValue) {
            opt.selected = true;
        }
        dropdown.appendChild(opt);
    });
});
}

        function updateAircraftCount() {
        let visibleRows;   
        if (unavailableIncluded) {
                // If unavailable are included, count all filtered rows
        visibleRows = filteredRows.length;
        } else {
                // If unavailable are excluded, only count non-maintenance rows
        visibleRows = filteredRows.filter(row => !row.classList.contains('maintenance')).length;
        }   
        document.getElementById('aircraftCount').innerText = visibleRows;
        }

        function openColumnModal() {
        document.getElementById('columnModal').style.display = 'block';
        }

        function closeColumnModal() {
        document.getElementById('columnModal').style.display = 'none';
        }

        // Close modal if clicking outside of it
        window.onclick = function(event) {
        const modal = document.getElementById('columnModal');
        if (event.target == modal) {
        closeColumnModal();
        }
        }



// ===========================================
// Detail Panel Functions
// ===========================================
function togglePanel() {
    const panel = document.getElementById('slidePanel');
    const button = document.getElementById('togglePanel');
    const arrow = document.getElementById('toggleArrow');
    const mainContent = document.querySelector('.main-content');
    
    isPanelOpen = !isPanelOpen;
    if (isPanelOpen) {
        panel.classList.add('active');
        button.classList.remove('inactive');
        button.classList.add('active');
        arrow.textContent = '▶';
        mainContent.classList.add('shifted');
    } else {
        panel.classList.remove('active');
        button.classList.remove('active');
        button.classList.add('inactive');
        arrow.textContent = '◀';
        mainContent.classList.remove('shifted');
    }
}

function formatAltitude(meters) {
    return `${Math.round((meters || 0) * 3.28084).toLocaleString()} Ft`;
}

function generateMissionBlock(missionName, missionType, missionSubType, missionActive, missionStartTime, missionEndTime) {
    if (missionName === "N/A" || missionName === "") return '';
    
    return `
        <div class="detail-group">
            <span class="collapse-arrow" onclick="toggleDetailGroup(this)">▼</span>
            <h4>Mission Information</h4>
            <div class="detail-content">
                <div class="detail-row"><span class="label">Mission Name: </span><span>${missionName}</span></div>
                <div class="detail-row"><span class="label">Mission Type: </span><span>${missionType}</span></div>
                ${missionSubType !== "N/A" ? `<div class="detail-row"><span class="label">Mission Subtype: </span><span>${missionSubType}</span></div>` : ''}
                <div class="detail-row"><span class="label">Status: </span><span>${missionActive === 'true' ? 'Active' : 'Inactive'}</span></div>
                ${missionStartTime && missionStartTime !== 'N/A' && missionStartTime !== '' ? 
                    `<div class="detail-row"><span class="label">Activation Time: </span><span>${missionStartTime}</span></div>` : ''}
                ${missionEndTime && missionEndTime !== 'N/A' && missionEndTime !== '' ? 
                    `<div class="detail-row"><span class="label">Deactivation Time: </span><span>${missionEndTime}</span></div>` : ''}
            </div>
        </div>`;
}

// ===========================================
// Utility Functions
// ===========================================
function getTimeOfDayDot(loTOD, currentTOD) {
    const todState = {
        '0': 'Day',
        '2': 'Night',
        '3': 'Dawn',
        '4': 'Dusk'
    };
    const currentState = todState[currentTOD] || 'Unknown';

    if (loTOD === '0' || loTOD === '1001') {
        return `<span class="status-dot" style="background-color: #9b59b6;" title="Unit is in: ${currentState}"></span>`;
    }

    if (loTOD === '2001') {
        return `<span class="status-dot" style="background-color: #2ecc71;" title="Unit is in: ${currentState}"></span>`;
    }

    if (loTOD === '2002') {
        switch(currentTOD) {
            case '2': return `<span class="status-dot" style="background-color: #2ecc71;" title="Unit is in: ${currentState} - Compatible"></span>`;
            case '0': return `<span class="status-dot" style="background-color: #e74c3c;" title="Unit is in: ${currentState} - Incompatible"></span>`;
            case '4': return `<span class="status-dot" style="background-color: #f1c40f;" title="Unit is in: ${currentState} - Caution"></span>`;
            case '3': return `<span class="status-dot" style="background-color: #e67e22;" title="Unit is in: ${currentState} - Warning"></span>`;
        }
    }

    if (loTOD === '2003') {
        switch(currentTOD) {
            case '0': return `<span class="status-dot" style="background-color: #2ecc71;" title="Unit is in: ${currentState} - Compatible"></span>`;
            case '2': return `<span class="status-dot" style="background-color: #e74c3c;" title="Unit is in: ${currentState} - Incompatible"></span>`;
            case '3': return `<span class="status-dot" style="background-color: #f1c40f;" title="Unit is in: ${currentState} - Caution"></span>`;
            case '4': return `<span class="status-dot" style="background-color: #e67e22;" title="Unit is in: ${currentState} - Warning"></span>`;
        }
    }

    return '';
}

function formatReadyTime(readyTime) {
    if (readyTime === 'Ready') {
        return `<span style="color: #3498db;">${readyTime}</span>`; // Blue
    }
    
    // Function to convert time string to minutes
    function convertToMinutes(timeStr) {
        if (!timeStr) return 0;
        
        // Check for hour format
        if (timeStr.includes('hr')) {
            const parts = timeStr.split(' ');
            let totalMinutes = 0;
            for (let i = 0; i < parts.length; i += 2) {
                const value = parseInt(parts[i]);
                const unit = parts[i + 1];
                if (unit.includes('hr')) {
                    totalMinutes += value * 60;
                } else if (unit.includes('min')) {
                    totalMinutes += value;
                } else if (unit.includes('sec')) {
                    totalMinutes += value / 60;
                }
            }
            return totalMinutes;
        }
        
        // Check for MM:SS format
        if (timeStr.includes(':')) {
            const [minutes, seconds] = timeStr.split(':').map(Number);
            return minutes + (seconds / 60);
        }
        
        return parseInt(timeStr);
    }

    const timeInMinutes = convertToMinutes(readyTime);
    if (isNaN(timeInMinutes)) return readyTime;
    
    if (timeInMinutes < 15) {
        return `<span style="color: #2ecc71;">${readyTime}</span>`; // Green
    } else if (timeInMinutes < 60) {
        return `<span style="color: #f1c40f;">${readyTime}</span>`; // Yellow
    } else {
        return `<span style="color: #e67e22;">${readyTime}</span>`; // Orange
    }
}

function debounce(func, wait) {
    let timeout;
    return function(...args) {
        clearTimeout(timeout);
        timeout = setTimeout(() => func.apply(this, args), wait);
    };
}

function generateWeaponsSection(weaponsInfo) {
    if (!weaponsInfo) return '';
    
    return weaponsInfo.split('|').map(weapon => {
        const [name, current, max, type, dbid, targets, ranges] = weapon.split(';');
        
        // Only create targets HTML if there are targets
        const targetList = targets ? targets.split(',').map(target => 
            `<div class="weapon-detail-subline">• ${target.trim()}</div>`
        ).join('') : '';

        const targetHtml = targetList ? `
            <div class="weapon-detail-line">
                <span class="detail-label">Valid Targets:</span>
            </div>
            <div class="weapon-target-list">
                ${targetList}
            </div>` : '';
        
        // Process ranges
        let rangeDisplay = '';
        if (ranges) {
            rangeDisplay = ranges.split(';').map(range => {
                const [domain, values] = range.split(':');
                const [min, max] = values.split('-');
                return `<div class="weapon-detail-line">
                    <span class="detail-label">${domain.charAt(0).toUpperCase() + domain.slice(1)} Range:</span> ${min} - ${max} NM
                </div>`;
            }).join('');
        }

        return `
            <div class="weapon-container">
                <div class="weapon-line">• ${name} (${current}/${max})</div>
                <div class="weapon-details collapsed">
                    <div class="weapon-detail-line">
                        <span class="detail-label">Type:</span> ${weaponTypes[type] || type}
                    </div>
                    ${rangeDisplay}
                    ${targetHtml}
                </div>
            </div>
        `;
    }).join('');
}

function generateSensorSection(sensors) {
    if (!sensors.length) return '';
    
    return `
        <div class="detail-row"><span class="label">Sensors:</span></div>
        <div class="weapons-section">
            <div class="weapons-header">
                <button class="details-button" 
                        onclick="toggleAllSensorDetails(this)" 
                        title="Only Radar, ECM and SensorGroup">Details</button>
            </div>
            ${sensors.map(sensor => `
                <div class="weapon-container">
                    <div class="weapon-line">• ${sensor.name} (${sensor.type}) - ${sensor.active}<span class="status-dot ${sensor.active.toLowerCase()}"></span></div>
                    <div class="weapon-details collapsed">
                        <div class="weapon-detail-line">
                            <span class="detail-label">Role:</span> ${sensor.role}
                        </div>
                        ${(sensor.maxRange && sensor.maxRange > 0) ? `
                            <div class="weapon-detail-line">
                                <span class="detail-label">Range:</span> ${sensor.maxRange} nm
                            </div>
                        ` : ''}
                    </div>
                </div>
            `).join('')}
        </div>
    `;
}



function showUnitDetails(name, subtype, className, base, loadout, readyTime, condition, airborneTime, crew, dbid, proficiency, 
                      latitude, longitude, jammer, jammed, baseLatitude, baseLongitude, horizontalDist, slantDist, 
                      groupName, missionName, missionType, missionActive, missionStartTime, missionEndTime, 
                      fuelInfo, altitude, agl, sensorInfo, missionSubType, loadoutRole, loadoutDBID, 
                      loadoutRoleCode, loadoutWeatherCode, loadoutTODCode, weaponsInfo, guid, currentTOD) {  // Added currentTOD here
    try {
        // Convert measurements
        const altitudeInFeet = formatAltitude(altitude);
        const aglInFeet = formatAltitude(agl);

        // Parse sensor info
        const sensors = sensorInfo ? sensorInfo.split('|').map(sensor => {
            const [name, type, role, active, maxRange] = sensor.split(';');
            return { name, type, role, active, maxRange };
        }) : [];

        const detailsHtml = `
            <div class="panel-header">
                <h3>Unit Details: ${name}</h3>
                <button class="toggle-all-button" onclick="toggleAllGroups()">Collapse All</button>
            </div>
            
            <div class="detail-group">
    <span class="collapse-arrow" onclick="toggleDetailGroup(this)">▼</span>
    <h4>Basic Information</h4>
    <div class="detail-content">
        <div class="detail-row"><span class="label">Class: </span><span>${className}</span></div>
        <div class="detail-row"><span class="label">Type: </span><span>${subtype}</span></div>
        ${groupName && groupName !== '' ? 
            `<div class="detail-row"><span class="label">Group: </span><span>${groupName}</span></div>` : ''}
    </div>
</div>

            <div class="detail-group">
                <span class="collapse-arrow" onclick="toggleDetailGroup(this)">▼</span>
                <h4>Location Information</h4>
                <div class="detail-content">
                    <div class="detail-row"><span class="label">Position: </span><span>${formatCoordinates(latitude, true)} ${formatCoordinates(longitude, false)}</span></div>
                    ${altitudeInFeet === aglInFeet ? 
                        `<div class="detail-row"><span class="label">Altitude ASL/AGL: </span><span>${altitudeInFeet}</span></div>` 
                        : 
                        `<div class="detail-row"><span class="label">Altitude ASL: </span><span>${altitudeInFeet}</span></div>
                        <div class="detail-row"><span class="label">Altitude AGL: </span><span>${aglInFeet}</span></div>`
                    }
                <div class="detail-row"><span class="label">Homebase: </span><span>${base}</span></div>
                <div class="detail-row"><span class="label">Base Position: </span><span>${formatCoordinates(baseLatitude, true)} ${formatCoordinates(baseLongitude, false)}</span></div>
                <div class="detail-row"><span class="label">Distance: </span><span>${typeof horizontalDist === 'number' ? horizontalDist.toFixed(1) : horizontalDist} NM</span></div>
                
                <button onclick="toggleMap()" class="export-button" id="mapToggleButton" style="margin-top: 10px;" title="When <1 nm only showing A/C position">Show Map</button>
                <!-- Map container -->
                <div id="locationMap" style="height: 300px; margin-top: 10px; display: none;"></div>
            </div>
            </div>

            <div class="detail-group">
                <span class="collapse-arrow" onclick="toggleDetailGroup(this)">▼</span>
                <h4>Status Information</h4>
                <div class="detail-content">
                    <div class="detail-row"><span class="label">Condition: </span><span>${condition}</span></div>
                    ${IsAirborne(condition) ? `
                        <div class="detail-row"><span class="label">Airborne Time: </span><span>${airborneTime}</span></div>
                        <div class="detail-row">
                            <div style="display: flex; flex-direction: column; width: 100%%;">
                                <div style="display: flex; align-items: center;">
                                    <span class="label">Fuel: </span>
                                    <span class="fuel-name" style="margin-left: 4px;">${getFuelName(fuelInfo)}</span>
                                </div>
                                <div class="fuel-bar-container">
                                    <div class="fuel-bar" style="width: ${calculateFuelPercentage(fuelInfo)}%%; background-color: ${getFuelBarColor(calculateFuelPercentage(fuelInfo))}"></div>
                                </div>
                                <span class="fuel-text">${getFuelDetails(fuelInfo)}</span>
                            </div>
                        </div>` : ''}
                    <div class="detail-row"><span class="label">Crew: </span><span>${crew}</span></div>
                    <div class="detail-row">
                        <span class="label">Proficiency: </span>
                        <span>${proficiency}<div class="proficiency-dot-panel ${proficiency.toLowerCase()}"></div></span>
                    </div>
                </div>
            </div>

<div class="detail-group">
   <span class="collapse-arrow" onclick="toggleDetailGroup(this)">▼</span>
   <h4>Readiness & LO Information</h4>
   <div class="detail-content">
       <div class="detail-row"><span class="label">Ready Time: </span><span>${formatReadyTime(readyTime)}</span></div>
       <div class="detail-row">
           <span class="label">Loadout: </span>
           <span title="DBID: ${loadoutDBID}">${loadout}</span>
       </div>
       <div class="detail-row"><span class="label">LO Role: </span><span>${loadoutRoles[loadoutRoleCode]}</span></div>
       <div class="detail-row"><span class="label">LO Weather: </span><span>${loadoutWeather[loadoutWeatherCode]}</span></div>
       <div class="detail-row"><span class="label">LO TOD: </span><span>${loadoutTimeOfDay[loadoutTODCode]}${getTimeOfDayDot(loadoutTODCode, currentTOD)}</span></div>
       
       ${weaponsInfo ? `
           <div class="detail-row weapons-section">
               <div class="weapons-header">
                   <span class="label">Weapons:</span>
                   <button class="details-button" onclick="toggleAllWeaponDetails(this)">Details</button>
               </div>
               ${generateWeaponsSection(weaponsInfo)}
           </div>
       ` : ''}
   </div>
</div>

            ${generateMissionBlock(missionName, missionType, missionSubType, missionActive, missionStartTime, missionEndTime)}

${(IsAirborne(condition) && 
   (sensorInfo || 
    jammer !== 'N/A' || 
    jammed !== 'N/A')) ? `
    <div class="detail-group">
        <span class="collapse-arrow" onclick="toggleDetailGroup(this)">▼</span>
        <h4>Electronic Warfare</h4>
        <div class="detail-content">
            <div class="detail-row"><span class="label">Jamming: </span><span>${jammer}</span></div>
            <div class="detail-row"><span class="label">Jammed: </span><span>${jammed}</span></div>
            ${generateSensorSection(sensors)}
        </div>
    </div>
` : ''}

            <div class="detail-group">
                <span class="collapse-arrow" onclick="toggleDetailGroup(this)">▼</span>
                <h4>Notes</h4>
                <div class="detail-content">
                    <div class="detail-row">
                        <textarea class="notes-field"
                            placeholder="Enter notes for this unit..."
                            data-guid="${guid}"
                            onchange="debouncedSave(this)"
                            rows="4">${currentNotes[guid] || ""}</textarea>
                    </div>
                </div>
            </div>
        `;
        // Update the DOM and toggle panel
        document.getElementById('unitDetails').innerHTML = detailsHtml;
        if (!isPanelOpen) {
            togglePanel();
        }

        function getNATOIcon(type) {
            const icons = {
                aircraft: `<svg viewBox="0 0 24 24" width="24" height="24">
                    <circle fill="none" stroke="white" stroke-width="2" cx="12" cy="12" r="10"/>
                    <path stroke="white" stroke-width="2" d="M6,12L18,12M12,6L12,18"/>
                </svg>`,
                base: `<svg viewBox="0 0 24 24" width="24" height="24">
                    <rect fill="none" stroke="white" stroke-width="2" x="4" y="4" width="16" height="16"/>
                    <path stroke="white" stroke-width="2" d="M4,12L20,12M12,4L12,20"/>
                </svg>`
            };
            return icons[type] || icons.aircraft;
        }

        // Initialize map if coordinates are available
        if (latitude && longitude) {
            const centerLat = (parseFloat(latitude) + parseFloat(baseLatitude)) / 2;
            const centerLon = (parseFloat(longitude) + parseFloat(baseLongitude)) / 2;
           
            window.currentMap = L.map('locationMap').setView([centerLat, centerLon], 5);
            L.tileLayer('https://{s}.basemaps.cartocdn.com/dark_all/{z}/{x}/{y}{r}.png', {
                maxZoom: 14
            }).addTo(window.currentMap);
           
            // Unit marker
            L.marker([latitude, longitude], {
                icon: L.divIcon({
                    className: 'unit-marker',
                    html: getNATOIcon('aircraft'),
                    iconSize: [24, 24]
                })
            }).bindPopup(`${name} (Unit Position)`)
              .addTo(window.currentMap);

            if (baseLatitude && baseLongitude) {
                const distanceInNM = typeof horizontalDist === 'number' ? horizontalDist : 999;
               
                if (distanceInNM >= 1) {
                    // Base marker
                    L.marker([baseLatitude, baseLongitude], {
                        icon: L.divIcon({
                            className: 'base-marker',
                            html: getNATOIcon('base'),
                            iconSize: [24, 24]
                        })
                    }).bindPopup(`${base} (Homebase)`)
                      .addTo(window.currentMap);
                   
                    // Draw line between unit and base
                    L.polyline([ [latitude, longitude], [baseLatitude, baseLongitude] ], {
                        color: "#4a4a4a",
                        dashArray: "5, 10",
                        weight: 2
                    }).addTo(window.currentMap);
                }
            }
        }
    } catch (error) {
        console.error('Error showing unit details:', error);
        document.getElementById('unitDetails').innerHTML = `
            <div class="error-message">
                Error loading unit details: ${error.message}
                <br>
                Please try again.
            </div>
        `;
    }
}

// ===========================================
// Utility Functions
// ===========================================
    function debounce(func, wait) {
        let timeout;
        return function(...args) {
            clearTimeout(timeout);
            timeout = setTimeout(() => func.apply(this, args), wait);
        };
    }

function formatCoordinates(decimal, isLatitude) {
        // Ensure we're working with a positive number for the calculation
        let absolute = Math.abs(decimal);
        
        // Calculate degrees, minutes, and seconds
        let degrees = Math.floor(absolute);
        let minutesDecimal = (absolute - degrees) * 60;
        let minutes = Math.floor(minutesDecimal);
        let seconds = Math.floor((minutesDecimal - minutes) * 60);
        
        // Determine hemisphere
        let direction = '';
        if (isLatitude) {
            direction = decimal >= 0 ? 'N' : 'S';
        } else {
            direction = decimal >= 0 ? 'E' : 'W';
        }
        
        // Format the string in CMO style
        return `${direction}${degrees.toString().padStart(2, '0')}.${minutes.toString().padStart(2, '0')}.${seconds.toString().padStart(2, '0')}`;
    }

    function selectUnitInGame(guid, latitude, longitude) {
        // Select the unit in unit status window
        window.chrome.webview.postMessage(`DIALOG_OKUI_SelectThisUnit('${guid}',true)`);
        // Center the camera on the unit
        window.chrome.webview.postMessage(`DIALOG_OKUI_SetCameraView(${latitude},${longitude})`);
    }

function calculateFuelPercentage(fuelInfo) {
    if (fuelInfo === "No fuel data available") return 0;
    
    const match = fuelInfo.match(/current: ([\d.]+), max: ([\d.]+)/);
    if (!match) return 0;
    
    const current = parseFloat(match[1]);
    const max = parseFloat(match[2]);
    
    return Math.round((current / max) * 100);
}

function getFuelName(fuelInfo) {
    if (fuelInfo === "No fuel data available") return "N/A";
    const match = fuelInfo.match(/name: ([^,]+),/);
    return match ? match[1] : "N/A";
}

function getFuelInfo(fuelInfo) {
    if (fuelInfo === "No fuel data available") {
        return {
            name: "N/A",
            current: 0,
            max: 0,
            percentage: 0
        };
    }

    const nameMatch = fuelInfo.match(/name: ([^,]+),/);
    const valuesMatch = fuelInfo.match(/current: ([\d.]+), max: ([\d.]+)/);

    return {
        name: nameMatch ? nameMatch[1] : "N/A",
        current: valuesMatch ? parseFloat(valuesMatch[1]) : 0,
        max: valuesMatch ? parseFloat(valuesMatch[2]) : 0,
        get percentage() {
            return this.max ? Math.round((this.current / this.max) * 100) : 0;
        }
    };
}

function getFuelDetails(fuelInfo) {
    if (fuelInfo === "No fuel data available") return "No fuel data available";
    const match = fuelInfo.match(/current: ([\d.]+), max: ([\d.]+)/);
    if (!match) return "No fuel data available";
    return `Current: ${match[1]} kg / Max: ${match[2]} kg`;
}

function getFuelBarColor(percentage) {
    if (percentage >= CONFIG.MIN_FUEL_HIGH) return '#2d8659';
    if (percentage >= CONFIG.MIN_FUEL_MEDIUM) return '#cc7000';
    return '#e74c3c';
}

// ===========================================
// Toggle map view
// ===========================================
function toggleMap() {
    const mapContainer = document.getElementById('locationMap');
    const toggleButton = document.getElementById('mapToggleButton');
    
    if (mapContainer.style.display === 'none') {
        mapContainer.style.display = 'block';
        toggleButton.textContent = 'Hide Map';
        // Refresh the map since it might not render properly when hidden
        if (window.currentMap) {
            window.currentMap.invalidateSize();
        }
    } else {
        mapContainer.style.display = 'none';
        toggleButton.textContent = 'Show Map';
    }
}

// ===========================================
// Collapse data blocks in SidePanel
// ===========================================
let allCollapsed = false;

function toggleAllGroups() {
    const groups = document.querySelectorAll('.detail-group');
    allCollapsed = !allCollapsed;
    
    groups.forEach(group => {
        if (allCollapsed) {
            group.classList.add('collapsed');
        } else {
            group.classList.remove('collapsed');
        }
    });
    
    // Update button text
    const button = document.querySelector('.toggle-all-button');
    button.textContent = allCollapsed ? 'Expand All' : 'Collapse All';
}

// ===========================================
// Initialization
// ===========================================
function debugCategories() {
    const rows = document.querySelectorAll('#aircraftTableBody tr');
    let categories = new Set();
    rows.forEach(row => {
        categories.add(row.getAttribute('data-category'));
        console.log(`Row ${row.cells[0].innerText}: category = ${row.getAttribute('data-category')}`);
    });
    console.log('Unique categories:', Array.from(categories));
}


document.addEventListener('DOMContentLoaded', () => {
   // Add keyboard navigation event listener
   document.addEventListener('keydown', function(event) {
       // Only respond to Shift + Arrow keys
       if (event.shiftKey) {
           switch(event.key) {
               case 'ArrowLeft':
                   if (currentPage > 1) {
                       currentPage--;
                       displayRows();
                   }
                   break;
               case 'ArrowRight':
                   const totalPages = Math.ceil(filteredRows.length / rowsPerPage);
                   if (currentPage < totalPages) {
                       currentPage++;
                       displayRows();
                   }
                   break;
           }
       }
       debugCategories();
   });

   // Initialize table
   populateDropdowns();
   filteredRows = Array.from(document.querySelectorAll('#aircraftTableBody tr'));
   sortTable(2);  // Sort by Class column at startup
   displayRows();
   updateAircraftCount();
 
   // Hide Proficiency column by default
   toggleColumn(8);
   toggleColumn(9);

   // Add keyboard navigation hint to pagination
   const paginationDiv = document.querySelector('.pagination');
   const hint = document.createElement('div');
   hint.style.color = '#888888';
   hint.style.fontSize = '12px';
   hint.style.marginTop = '5px';
   hint.textContent = 'Use Shift + ← → arrows to navigate pages';
   paginationDiv.appendChild(hint);

   // Update ready time colors - wrapped in try-catch
   try {
       document.querySelectorAll('#readyTime').forEach(cell => {
           cell.innerHTML = formatReadyTime(cell.textContent);
       });
   } catch (error) {
       console.error('Error updating ready times:', error);
   }
});

<!-- END OF JAVA SCRIPT -->
    </script>



</body>
</html>

]], 
sideName,
loadoutRolesJSON,
loadoutWeatherJSON,
loadoutTimeOfDayJSON,
weaponTypesJSON,
currentNotesJSON,
sideName,
aircraftCount,
tableRows)

ScenEdit_SpecialMessage("playerside", htmlAir)